// --------------------------------------------------------
// Copyright (c)
//
// contributions by Ansgar
//                  ansgar.radermacher@cea.fr
// maintained by    CEA LIST
//                  info-list@cea.fr

// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#ifndef ADDCLIENTCOMPDEF_ADDCLIENT_IMPL_H
#define ADDCLIENTCOMPDEF_ADDCLIENT_IMPL_H

/************************************************************
 AddClient_impl class header
 ************************************************************/

#include "addClientCompdef/Pkg_addClientCompdef.h"

#include "addClientCompdef/AddClient.h"
#include "simple_msgs/srv/add_service_def.hpp"

namespace ros2Library {
namespace rclcpp {
class Client;
}
}
namespace ros2Library {
namespace rclcpp {
class NodeOptions;
}
}

namespace addClientCompdef {

/************************************************************/
/**
 * This is a skeleton class generated for component AddClient
 * Copy it into the source folder as an initial base (or copy parts
 * of it whenever you add modify the component).
 * 
 */
class AddClient_impl: public AddClient {
public:

  /**
   * 
   * @param options 
   */
  AddClient_impl(rclcpp::NodeOptions /*in*/options);

  /**
   * 
   */
  void fOnActivate();

  /**
   * 
   */
  void fCallAdd();

  /**
   * 
   * @param future 
   */
  void fResultCallback(
      rclcpp::Client<simple_msgs::srv::AddServiceDef>::SharedFuture /*in*/future);

  /**
   * 
   */
  void fPeriodic();

};
/************************************************************/
/* External declarations (package visibility)               */
/************************************************************/

/* Inline functions                                         */

} // of namespace addClientCompdef

/************************************************************
 End of AddClient_impl class header
 ************************************************************/

#endif
